function isBlocklandRebuilt ()
{
	return false;
}

package chatEmotes
{
	function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %pre, %name, %suf, %msg, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		%message = detag(%msg);
		%prefix = detag(%pre);
		%suffix = detag(%suf);
		if ( strPos( %message, ":" ) >= 0 || strPos( %prefix, "<emote:" ) >= 0 || strPos( %suffix, "<emote:" ) >= 0 )
		{
			%chatcolor = (strPos(detag(%msgString),"\c4:") >= 0 ? "\c4" : "\c6");
			%message = peReplace( %message, %chatcolor);
			%prefix = peReplaceTag(%prefix);
			%suffix = peReplaceTag(%suffix);
			if(%message !$= detag(%msg) || %prefix !$= detag(%pre) || %suffix !$= detag(%suf)) // don't replace %msgString if message is identical
				%msgString = "\c7" @ %prefix @ "\c3" @ detag(%name) @ "\c7" @ %suffix @ %chatcolor @ ":" SPC %message;
		}
		parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %pre, %name, %suf, %msg, %a5, %a6, %a7, %a8, %a9, %a10);
	}
	
	// code to preview emotes being sent
	function OPT_SetChatSize (%val) {
		Parent::OPT_SetChatSize (%val);
		if (%val >= 0 && %val <= 10) {
			NMH_Preview.maxBitmapHeight = $NewChatSO.textObj.maxBitmapHeight;
			NMH_Preview.setProfile ("BlockChatTextSize" @ %val @ "Profile");
			NMH_Preview.setValue(NMH_Preview.getValue());
		}
	}

	function newMessageHud::open (%this, %channel)
	{
		if(NMH_Preview.isVisible())
			NMH_Preview.setVisible(false);
		return Parent::open (%this, %channel);
	}

	function newMessageHud::updatePosition (%this)
	{
		Parent::updatePosition (%this);
		%x = 2;
		%y = (getWord(NMH_Box.getPosition(),1) + getWord(NMH_Type.getExtent(),1));
		%w = getWord (NMH_Box.getExtent (), 0);
		%h = getWord (NMH_Preview.getExtent (), 1);
		NMH_Preview.resize(%x,%y,%w,%h);
	}

	function NMH_Type::type (%this)
	{
		if(newMessageHud.channel $= "SAY" || newMessageHud.channel $= "TEAM") {
			%text = %this.getValue ();

			if (strlen (%text) >= 1 && $Pref::Client::ChatEmotes::Preview)
			{
				%chatColor = (newMessageHud.channel $= "TEAM" ? "\c4" : "\c6");
				
				%parsedMessage = chatWhiteListFilter (%text);
				%parsedMessage = StripMLControlChars (%parsedMessage);
				
				// copied from v21 and Rebuilt scripts in order to make the preview more faithful	
				if(!isBlocklandRebuilt() && $Version >= 21 && getBuildNumber() >= 1954)
				{
					%protocol = "http://";
					%protocolLen = strlen(%protocol);
					%urlStart = strpos(%parsedMessage, %protocol);
					if(%urlStart == -1.0)
					{
						%protocol = "https://";
						%protocolLen = strlen(%protocol);
						%urlStart = strpos(%parsedMessage, %protocol);
					}
					if(%urlStart == -1.0)
					{
						%protocol = "ftp://";
						%protocolLen = strlen(%protocol);
						%urlStart = strpos(%parsedMessage, %protocol);
					}
					if(%urlStart != -1.0)
					{
						%urlEnd = strpos(%parsedMessage, " ", %urlStart + 1.0);
						%skipProtocol = 0;
						if(%protocol $= "http://")
							%skipProtocol = 1;
						if(%urlEnd == -1.0)
						{
							%fullUrl = getSubStr(%parsedMessage, %urlStart, strlen(%parsedMessage) - %urlStart);
							%url = getSubStr(%parsedMessage, %urlStart + %protocolLen, strlen(%parsedMessage) - %urlStart - %protocolLen);
						}
						else
						{
							%fullUrl = getSubStr(%parsedMessage, %urlStart, %urlEnd - %urlStart);
							%url = getSubStr(%parsedMessage, %urlStart + %protocolLen, %urlEnd - %urlStart - %protocolLen);
						}
						if(strlen(%url) > 0.0)
						{
							%url = strreplace(%url, "<", "");
							%url = strreplace(%url, ">", "");
							if (%skipProtocol)
								%newText = strreplace(%parsedMessage, %fullUrl, "<a:" @ %url @ ">" @ %url @ "</a>\c6");
							else
								%newText = strreplace(%parsedMessage, %fullUrl, "<a:" @ %protocol @ %url @ ">" @ %url @ "</a>\c6");
							%parsedMessage = %newText;
						}
					}
				}
				else
				{
					%protocolLen = 7;
					%urlStart = strpos (%parsedMessage, "http://");
					if (%urlStart == -1)
					{
						%protocolLen = 8;
						%urlStart = strpos (%parsedMessage, "https://");
					}
					if (%urlStart == -1)
					{
						%protocolLen = 6;
						%urlStart = strpos (%parsedMessage, "ftp://");
					}
					if (%urlStart != -1)
					{
						%urlEnd = strpos (%parsedMessage, " ", %urlStart + 1);
						if (%urlEnd == -1)
						{
							%fullUrl = getSubStr (%parsedMessage, %urlStart, strlen (%parsedMessage) - %urlStart);
							%url = getSubStr (%parsedMessage, %urlStart + %protocolLen, (strlen (%parsedMessage) - %urlStart) - %protocolLen);
						}
						else 
						{
							%fullUrl = getSubStr (%parsedMessage, %urlStart, %urlEnd - %urlStart);
							%url = getSubStr (%parsedMessage, %urlStart + %protocolLen, (%urlEnd - %urlStart) - %protocolLen);
						}
						if (strlen (%url) > 0)
						{
							%url = strreplace (%url, "<", "");
							%url = strreplace (%url, ">", "");
							%newText = strreplace (%parsedMessage, %fullUrl, "<a:" @ %url @ ">" @ %url @ "</a>\c6");
							%parsedMessage = %newText;
						}
					}
				}
				
				%parsedMessage = peReplace(%parsedMessage,%chatColor);

				%previewPref = $Pref::Client::ChatEmotes::Preview;
				if (getSubStr (%text, 0, 1) !$= "/" && (
						(%previewPref >= 1 && %text !$= %parsedMessage) ||
						(%previewPref == 2 && strstr (%text, ":") != -1) ||
						(%previewPref == 2 && strstr (%text, "<") != -1)
					))
				{
					NMH_Preview.position = "2" SPC (getWord(NMH_Box.getPosition(),1) + getWord(NMH_Type.getExtent(),1));
					if(!NMH_Preview.isVisible())
						NMH_Preview.setVisible(true);

					if(isBlocklandRebuilt() && atof ($Version) >= 2)
						NMH_Preview.setValue("\c3<textid:UI_PLAYGUI_CHATEMOTES_PREVIEW:Preview%s\\: :"@%chatColor@">"@trim(%parsedMessage));
					else
						NMH_Preview.setValue("\c3Preview" @ %chatColor @ ":" SPC %parsedMessage);
				} else
					if(NMH_Preview.isVisible())
						NMH_Preview.setVisible(false);
			} else
				if(NMH_Preview.isVisible())
					NMH_Preview.setVisible(false);
		}
		return Parent::type(%this);
	}
	

	function NMH_Type::send (%this)
	{
		NMH_Preview.setVisible(false);
		return Parent::send(%this);
	}
	
	function RTBMM_FileGrabber::onBinChunk(%this,%bin) {
		%addonZip = %this.queue.zip; // thanks ephialtes
		Parent::onBinChunk(%this,%bin);
		if (%bin >= %this.contentSize)
		{
			if (isWriteableFilename("Add-Ons/"@%addonZip))
			{
				if(strstr(strlwr(%addonZip),"chatemotes_") == 0) {
					%addonName = strReplace(%addonZip,".zip","");
					%emoteDescription = "Add-Ons/"@%addonName@"/description.txt";
					if(clientIsValidAddOn (%addonName, 1)) {
						if($Client::ChatEmotes::AmountEmotes[strReplace(strlwr(%addonName),"chatemotes_","")] > 0)
							deleteChatEmotes(%emoteDescription);
						createChatEmotes(%emoteDescription);
					}
				}
			}
		}
	}
	
	// packaged functions to add "emote" pseudo-TorqueML
	function onServerMessage(%message) {
		%message = peReplaceTag(%message);
		return Parent::onServerMessage(%message);
	}
	function clientCmdCenterPrint(%message, %time, %size) {
		%message = peReplaceTag(%message);
		return Parent::clientCmdCenterPrint(%message, %time, %size);
	}
	function clientCmdCenterPrint(%message, %time, %size) {
		%message = peReplaceTag(%message);
		return Parent::clientCmdCenterPrint(%message, %time, %size);
	}
	function clientCmdBottomPrint(%message, %time, %size) {
		%message = peReplaceTag(%message);
		return Parent::clientCmdBottomPrint(%message, %time, %size);
	}
	function clientCmdMessageBoxOK (%title, %message)
	{
		%message = peReplaceTag(%message);
		return Parent::clientCmdMessageBoxOK(%title, %message);
	}
	function clientCmdMessageBoxOKCancel (%title, %message, %okServerCmd, %cancelServerCmd)
	{
		%message = peReplaceTag(%message);
		return Parent::clientCmdMessageBoxOKCancel(%title, %message, %okServerCmd, %cancelServerCmd);
	}
	function clientCmdMessageBoxYesNo (%title, %message, %okServerCmd, %cancelServerCmd)
	{
		%message = peReplaceTag(%message);
		return Parent::clientCmdMessageBoxYesNo(%title, %message, %okServerCmd, %cancelServerCmd);
	}
};

activatePackage( "chatEmotes" );

if(!isObject(NMH_Preview)) {
	new GuiMLTextCtrl(NMH_Preview) {
		profile = "BlockChatTextSize4Profile";
		horizSizing = "width";
		vertSizing = "bottom";
		position = "2 0";
		extent = "636 24";
		minExtent = "8 2";
		visible = "0";
		lineSpacing = "2";
		allowColorChars = "1";
		maxChars = "-1";
		text = "\c3Preview\c6:";
		locale = ExpandFilename ("./lang/");
		maxBitmapHeight = "-1";
		selectable = "1";
	};
	newMessageHud.add(NMH_Preview);
	NMH_Preview.maxBitmapHeight = $NewChatSO.textObj.maxBitmapHeight;
	NMH_Preview.setProfile($NewChatSO.textObj.profile);
}

if(!isObject(ChatEmotes_Settings)) {
	new GuiSwatchCtrl(ChatEmotes_Settings) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "248 92";
		extent = "128 78";
		minExtent = "8 2";
		visible = "1";
		color = "0 32 112 2";
		locale = ExpandFilename ("./lang/");
		applyLocaleToChildren = true;

		new GuiTextCtrl() {
			profile = "GuiTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "106 18";
			minExtent = "8 2";
			visible = "1";
			text = "Chat Emotes Preview:";
			textID = "UI_CHATEMOTES_PREVIEW_OPTION";
			maxLength = "255";
		};
		new GuiRadioCtrl(ChatEmotes_Setting0) {
			profile = "GuiRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "8 16";
			extent = "120 25";
			minExtent = "8 2";
			visible = "1";
			command = "setChatEmotesPreview(0);";
			text = "Disabled";
			textID = "UI_CHATEMOTES_PREVIEW_NONE";
			ToolTip = "No preview is shown at all.";
			ToolTipID = "UI_CHATEMOTES_PREVIEW_NONE_DESCRIPTION";
			groupNum = "-1";
			buttonType = "RadioButton";
		};
		new GuiRadioCtrl(ChatEmotes_Setting1) {
			profile = "GuiRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "8 35";
			extent = "120 25";
			minExtent = "8 2";
			visible = "1";
			command = "setChatEmotesPreview(1);";
			text = "Parsed";
			textID = "UI_CHATEMOTES_PREVIEW_PARSE";
			ToolTip = "The preview is only shown if a valid emote has been typed.";
			ToolTipID = "UI_CHATEMOTES_PREVIEW_PARSE_DESCRIPTION";
			groupNum = "-1";
			buttonType = "RadioButton";
		};
		new GuiRadioCtrl(ChatEmotes_Setting2) {
			profile = "GuiRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "8 53";
			extent = "120 25";
			minExtent = "8 2";
			visible = "1";
			command = "setChatEmotesPreview(2);";
			text = "Typed";
			textID = "UI_CHATEMOTES_PREVIEW_TYPE";
			ToolTip = "The preview is shown if a colon has been typed.";
			ToolTipID = "UI_CHATEMOTES_PREVIEW_TYPE_DESCRIPTION";
			groupNum = "-1";
			buttonType = "RadioButton";
		};
	};
	// place config in advanced gui options besides chat settings
	ChatEmotes_Settings.position = (getWord(Opt_ChatLineTime.getPosition(),0) + getWord(Opt_ChatLineTime.getExtent(),0) + 4) SPC getWord(Opt_ChatLineTime.getPosition(),1);
	OptAdvGraphicsPane.getObject(2).getObject(0).getObject(2).add(ChatEmotes_Settings);
}

function ChatEmotes_Settings::onWake (%this) {
	if ($Pref::Client::ChatEmotes::Preview $= "")
		$Pref::Client::ChatEmotes::Preview = 2;

	for (%i = 0; %i < 3; %i++)
	{
		%obj = "ChatEmotes_Setting" @ %i;
		if (%i == $Pref::Client::ChatEmotes::Preview)
			%obj.setValue (1);
		else 
			%obj.setValue (0);
		
	}
}

function setChatEmotesPreview(%val) {
	$Pref::Client::ChatEmotes::Preview = mClamp(%val,0,2);
}

if($Pref::Client::ChatEmotes::Preview $= "")
	$Pref::Client::ChatEmotes::Preview = 2;

function peReplace(%str, %color)
{
	if(strPos(%str, ":") < 0)
		return %str;

	%new = "";
	%i = 0;
	while((%pos = strPos(%str, ":")) >= 0)
	{
		%i++;
		if (%i >= 1000)
		{
			error ("ERROR: peReplace() - loop safety hit");
			return %str;
		}
		%new = %new @ getSubStr(%str, 0, %pos);
		%str = getSubStr(%str, %pos + 1, strLen(%str));
		%end = strPos(%str, ":");
		%spc = strPos(%str, " ");
		
		if(%end < 1 || (%spc > 0 && %spc < %end))
		{
			%new = %new @ ":" @ getSubStr(%str, 0, 1);
			%str = getSubStr(%str, 1, strLen(%str));
			continue;
		}

		%code = getSubStr(":" @ %str, 0, %end + 2);
		%str = getSubStr(%str, %end + 1, strLen(%str));
		%newCheck = %new @ peParse(%code,%color);
		
		%new = %newCheck;
	}

	%new = %new @ %str;
	return %new;
}
function peReplaceTag(%str)
{
	if(strPos(%str, "<emote:") < 0)
		return %str;

	%i = 0;
	%new = "";
	while((%pos = strPos(%str, "<emote:")) >= 0)
	{
		%i++;
		if (%i >= 1000)
		{
			error ("ERROR: peReplaceTag() - loop safety hit");
			return %str;
		}
		%new = %new @ getSubStr(%str, 0, %pos);
		%str = getSubStr(%str, %pos + 7, strLen(%str));
		%end = strPos(%str, ">");
		
		if(%end < 1)
		{
			%new = %new @ "<emote:" @ getSubStr(%str, 0, 1);
			%str = getSubStr(%str, 1, strLen(%str));
			continue;
		}

		%code = getSubStr(%str, 0, %end);
		%str = getSubStr(%str, %end + 1, strLen(%str));
		%newCheck = %new @ peParse(":"@%code@":");
		
		%new = %newCheck;
	}

	%new = %new @ %str;
	return %new;
}
function peParse(%code,%color)
{
	//check for special cases
	%path = "";
	if(getSubStr(%code, 1, 5) $= "glass") //glass icons support
		%path = "Add-Ons/System_BlocklandGlass/image/icon/" @ getSubStr(%code, 6, strLen(%code) - 7) @ ".png";
	else if(getSubStr(%code, 1, 3) $= "rtb") //rtb icons support
		%path = "Add-Ons/System_ReturnToBlockland/images/icons/" @ getSubStr(%code, 4, strLen(%code) - 5) @ ".png";
	else if(getSubStr(%code, 1, 6) $= "letter") //print letters
		%path = "Add-Ons/Print_Letters_Default/icons/" @ getSubStr(%code, 7, strLen(%code) - 8) @ ".png";
	else if(getSubStr(%code, 1, 2) $= "ci") //ci icons support with some hard coded stuff
	{
		if(%code $= ":ciarrow:") //arrow ci
			%path = "Add-Ons/Weapon_Bow/CI_arrow.png";
		else if(%code $= ":cigun:") //gun ci
			%path = "Add-Ons/Weapon_Gun/CI_gun.png";
		else if(%code $= ":ci2guns:") //2guns ci
			%path = "Add-Ons/Weapon_Guns_Akimbo/CI_2guns.png";
		else if(%code $= ":cirocket:") //rocket ci
			%path = "Add-Ons/Weapon_Rocket_Launcher/CI_rocket.png";
		else if(%code $= ":cirocketradius:") //rocket radius ci
			%path = "Add-Ons/Weapon_Rocket_Launcher/CI_rocketRadius.png";
		else if(%code $= ":cispear:") //spear ci
			%path = "Add-Ons/Weapon_Spear/CI_spear.png";
		else if(%code $= ":cispearradius:") //spear radius ci
			%path = "Add-Ons/Weapon_Spear/CI_spearRadius.png";
		else if(%code $= ":cisword:") //sword ci
			%path = "Add-Ons/Weapon_Sword/CI_sword.png";
		else if(%code $= ":ciball:") //cannon ci
			%path = "Add-Ons/Vehicle_Pirate_Cannon/ball.png";
		else if(%code $= ":ciballradius:") //cannon radius ci
			%path = "Add-Ons/Vehicle_Pirate_Cannon/ballradius.png";
		else if(%code $= ":cifire:") //fire ci
			%path = "Add-Ons/GameMode_Blockheads_Ruin_Xmas/CI_Fire.png";
		else if(%code $= ":cimelee:") //melee ci
			%path = "Add-Ons/Bot_Hole/CI_Melee.png";
		else //if it's none of the above, we check in base/client/ui/ci
			%path = "base/client/ui/ci/" @ getSubStr(%code, 3, strLen(%code) - 4) @ ".png";
	}
	else if(getSubStr(%code, 1, 2) $= "ui") //ui icons support with some hard coded stuff
	{
		if(%code $= ":uilag:") //lag
			%path = "base/client/ui/lagIcon.png";
		else //if it's none of the above, we check in base/client/ui/plantErrors_small
			%path = "base/client/ui/plantErrors_small/plantError_" @ getSubStr(%code, 3, strLen(%code) - 4) @ ".png";
	}
	else if(%code $= ":tm:")
		return (isBlocklandRebuilt() && atof ($Version) >= 2 ? "\u2122" : "\x99");
	else if(%code $= ":copyright:")
		return (isBlocklandRebuilt() && atof ($Version) >= 2 ? "\u00A9" : "\xA9");
	else if(%code $= ":registered:")
		return (isBlocklandRebuilt() && atof ($Version) >= 2 ? "\u00AE" : "\xAE");
	
	//catch if no special case occured
	if(!isFile(%path))
		%path = $Client::ChatEmotes::Path[%code];	
	
	%meta = "";
	if($Client::ChatEmotes::Meta[%code] !$= "")
		%meta = ":" @ $Client::ChatEmotes::Meta[%code];
	
	//make sure its real
	if(%path $= "")
		return %code;
	if(strPos(%path, ":") == -1 && !isFile(%path))
		return %code;
	
	return "<bitmap:" @ %path @ %meta @ ">" @ (!isBlocklandRebuilt() ? %color : "");
}
$PE::Path = "base/emotes";

function loadChatEmoteAddOns()
{
	%addonPattern = "Add-Ons/ChatEmotes_*/description.txt";
	
	%descriptionFile = findFirstFile(%addonPattern);
	while(%descriptionFile !$= "")
	{
		$Client::ChatEmotes::AmountAddons++;
		$Client::ChatEmotes::Addon[$Client::ChatEmotes::AmountAddons] = %descriptionFile;
		if($Client::ChatEmotes::AmountAddons != 1 && $Client::ChatEmotes::Addon[$Client::ChatEmotes::AmountAddons] $= $Client::ChatEmotes::Addon1)
			break;
		
		%descriptionFile = findNextFile(%addonPattern);
	}
	
	for(%a = 0; %a <= $Client::ChatEmotes::AmountAddons; %a++)
	{
		if(%a != 1 && $Client::ChatEmotes::Addon[%a] $= $Client::ChatEmotes::Addon1)
			break;
		
		if($Client::ChatEmotes::Addon[%a] !$= "") {
			%path = filePath ($Client::ChatEmotes::Addon[%a]);
			%dirName = getSubStr (%path, strlen ("Add-Ons/"), strlen (%path) - strlen ("Add-Ons/"));
			echo ("ChatEmotes checking Add-On: " @ %dirName);
			if(clientIsValidAddOn (%dirName, 1))
				createChatEmotes($Client::ChatEmotes::Addon[%a]);
		}
	}
}

function loadLegacyEmotes() {
	if(findFirstFile($PE::Path @ "/*.png") !$= "") {
		$Client::ChatEmotes::AmountAddons++;
		%legacyEmotePath = $Client::ChatEmotes::Addon[$Client::ChatEmotes::AmountAddons] = $PE::Path;
		createChatEmotes(%legacyEmotePath);
	}
}

function reloadChatEmotes() {
	deleteVariables("$Client::ChatEmotes::*");
	echo("");
	loadChatEmoteAddOns();
	loadLegacyEmotes();
}

function deleteChatEmotes(%addonFile)
{
	if(%addonFile $= $PE::Path) {
		echo("\c4Unloading chat emotes from " @ $PE::Path);
		%addonName = %addonFile @ "/*.png";
	} else {
		%addonName = getSubStr(%addonFile, 0, strlen(%addonFile) - 16); // description.txt
		%addonName = getSubStr(%addonName, 8, strlen(%addonName) - 8); // Add-Ons/
		echo("\c4Unloading chat emotes from " @ %addonName);
		%addonName = getSubStr(%addonName, 11, strlen(%addonName) - 11); // ChatEmotes_
	}

	for(%i=1; %i<=$Client::ChatEmotes::AmountAddons; %i++) {
		if($Client::ChatEmotes::Addon[%i] $= %addonFile) {
			for(%j=1; %j<=$Client::ChatEmotes::AmountEmotes[%addonName]; %j++) {
				deleteVariables("$Client::ChatEmotes::Path" @ $Client::ChatEmotes::Emote[%addonName, %j]);
				deleteVariables("$Client::ChatEmotes::Meta" @ $Client::ChatEmotes::Emote[%addonName, %j]);
			}
			deleteVariables("$Client::ChatEmotes::Emote" @ %addonName @ "_*");
			break;
		}
	}
	echo("\c1" @ "unloaded " @ $Client::ChatEmotes::AmountEmotes[%addonName] @ " chat emotes");
	$Client::ChatEmotes::AmountEmotes[%addonName] = 0;
	echo("");
}

function createChatEmotes(%addonFile)
{
	if(%addonFile $= $PE::Path) {
		echo("\c4Adding chat emotes from " @ $PE::Path);
	} else {
		%addonFile = getSubStr(%addonFile, 0, strlen(%addonFile) - 16); // /description.txt
		%addonName = getSubStr(%addonFile, 8, strlen(%addonFile) - 8); // Add-Ons/
		%zipFile = "Add-Ons/" @ %addonName @ ".zip";
		echo("\c4Adding chat emotes from " @ %addonName @ (isFile(%zipFile) ? " \c1(CRC:" @ getFileCRC(%zipFile) @ ")" : ""));
		%addonName = getSubStr(%addonName, 11, strlen(%addonName) - 11); // ChatEmotes_
	}
	$Client::ChatEmotes::AmountEmotes[%addonName] += 0;

	// emotes.txt format is one of the following per line:
	// emote_name	emote_path.png	src_x	src_y	src_w	src_h	dst_w	dst_h
	// emote_name	emote_path.png	src_x	src_y	src_w	src_h
	// emote_name	emote_path.png	dst_w	dst_h
	// emote_name	emote_path.png
	if(isFile(%addonFile @ "/emotes.txt")) {
		%metadata = new FileObject ("");
		%metadata.openForRead (%addonFile @ "/emotes.txt");
		%nonBLRWarn = false;
		while (!%metadata.isEOF ())
		{
			%line = %metadata.readLine ();
			%base = getField(%line, 0);
			
			if(%base $= "")
				continue; // skip line if it's empty

			if($Client::ChatEmotes::Path[":"@%base@":"] !$= "")
			{
				%conflictPath = filePath($Client::ChatEmotes::Path[":"@%base@":"]);
				if(%conflictDir !$= $PE::Path)
					%conflictDir = getSubStr(%conflictPath, 8, strlen(%conflictPath) - 8);
				warn("    \"" @ %base @ "\" already exists in " @ %conflictDir @ " - skipping");
				continue;
			}

			%base = ":" @ %base @ ":";
			%path = getField(%line, 1);

			if(strPos(%path, "/") == -1) // use relative path if there is no slash in the path
				%path = %addonFile @ "/" @ %path;

			if(strPos(%path, ":") == -1 && !isFile(%path)) {
				warn("    \"" @ %base @ "\" is missing bitmap file \"" @ %path @ "\" - skipping");
				continue;
			}

			else if(strPos(%path, ":") >= 0 && !(isBlocklandRebuilt() && atof ($Version) >= 2.15)) {
				if(!%nonBLRWarn) {
					warn("\c2This Add-On contains emotes that work only in Blockland Rebuilt.");
					%nonBLRWarn = 1; // don't warn for this add-on again
				}
				continue;
			}

			else if((isBlocklandRebuilt() && atof ($Version) >= 2.15) && getField(%line, 3) !$= "") {
				%src_x = getField(%line, 2); // x position
				%src_y = getField(%line, 3); // y position
				%src_w = getField(%line, 4); // width
				%src_h = getField(%line, 5); // height
				%dst_w = getField(%line, 6); // width to render
				%dst_h = getField(%line, 7); // height to render

				if(%dst_h !$= "")
					%meta = %src_x @ ":" @ %src_y @ ":" @ %src_w @ ":" @ %src_h @ ":" @ %dst_w @ ":" @ %dst_h;
				else if(%src_h !$= "")
					%meta = %src_x @ ":" @ %src_y @ ":" @ %src_w @ ":" @ %src_h;
				else if(%src_y !$= "")
					%meta = %src_x @ ":" @ %src_y;
				else // this should never happen
					%meta = "";

				$Client::ChatEmotes::Meta[%base] = %meta;
				$Client::ChatEmotes::Path[%base] = %path;
				$Client::ChatEmotes::AmountEmotes[%addonName]++;
				%amountEmotes = $Client::ChatEmotes::AmountEmotes[%addonName];
				$Client::ChatEmotes::Emote[%addonName, %amountEmotes] = %base;
			} else if(getField(%line, 4) $= "") {
				$Client::ChatEmotes::Path[%base] = %path;
				
				$Client::ChatEmotes::AmountEmotes[%addonName]++;
				%amountEmotes = $Client::ChatEmotes::AmountEmotes[%addonName];
				$Client::ChatEmotes::Emote[%addonName, %amountEmotes] = %base;
			} else if(!%nonBLRWarn) {
				warn("\c2This Add-On contains emotes that work only in Blockland Rebuilt.");
				%nonBLRWarn = 1; // don't warn for this add-on again
			}
		}
		%metadata.close ();
		%metadata.delete ();
	}
	else {
		%pattern = %addonFile @ "/*.png";
		$Client::ChatEmotes::AmountEmotes[%addonName] = 0;
		
		for(%file = findFirstFile(%pattern); %file !$= ""; %file = findNextFile(%pattern))
		{
			%base = fileBase(%file);
			
			if(strPos(%base, " ") != -1) {
				warn("    \"" @ %base @ "\" contains spaces - skipping");
				continue;
			}

			if($Client::ChatEmotes::Path[":"@%base@":"] !$= "")
			{
				%conflictPath = filePath($Client::ChatEmotes::Path[":"@%base@":"]);
				if(%conflictDir !$= $PE::Path)
					%conflictDir = getSubStr(%conflictPath, 8, strlen(%conflictPath) - 8);
				warn("    Emote \"" @ %base @ "\" already exists in " @ %conflictDir @ " - skipping");
				continue;
			}

			%base = ":" @ %base @ ":";
			$Client::ChatEmotes::Path[%base] = %file;
			$Client::ChatEmotes::AmountEmotes[%addonName]++;
			%amountEmotes = $Client::ChatEmotes::AmountEmotes[%addonName];
			$Client::ChatEmotes::Emote[%addonName, %amountEmotes] = %base;
		}
	}
	
	echo("\c1" @ "created " @ $Client::ChatEmotes::AmountEmotes[%addonName] @ " chat emotes");
	echo("");
}
reloadChatEmotes();
